<html>
<head>
<title>OgreController.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreController.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreController_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __Controller_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __Controller_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00054"></a>00054     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00055"></a><a class="code" href="classOgre_1_1ControllerFunction.html">00055</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ControllerAlloc</a>
<a name="l00056"></a>00056     {
<a name="l00057"></a>00057     <span class="keyword">protected</span>:
<a name="l00059"></a><a class="code" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5">00059</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5" title="If true, function will add input values together and wrap at 1.0 before evaluating.">mDeltaInput</a>;
<a name="l00060"></a><a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">00060</a>         T <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a>;
<a name="l00061"></a>00061 
<a name="l00064"></a><a class="code" href="classOgre_1_1ControllerFunction.html#a6c6a617c6db75b58e3e1a8a2e9dbed8e">00064</a>         T <a class="code" href="classOgre_1_1ControllerFunction.html#a6c6a617c6db75b58e3e1a8a2e9dbed8e" title="Gets the input value as adjusted by any delta.">getAdjustedInput</a>(T input)
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066             <span class="keywordflow">if</span> (<a class="code" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5" title="If true, function will add input values together and wrap at 1.0 before evaluating.">mDeltaInput</a>)
<a name="l00067"></a>00067             {
<a name="l00068"></a>00068                 <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> += input;
<a name="l00069"></a>00069                 <span class="comment">// Wrap</span>
<a name="l00070"></a>00070                 <span class="keywordflow">while</span> (<a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> &gt;= 1.0)
<a name="l00071"></a>00071                     <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> -= 1.0;
<a name="l00072"></a>00072                 <span class="keywordflow">while</span> (<a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> &lt; 0.0)
<a name="l00073"></a>00073                     <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> += 1.0;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075                 <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a>;
<a name="l00076"></a>00076             }
<a name="l00077"></a>00077             <span class="keywordflow">else</span>
<a name="l00078"></a>00078             {
<a name="l00079"></a>00079                 <span class="keywordflow">return</span> input;
<a name="l00080"></a>00080             }
<a name="l00081"></a>00081         }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     <span class="keyword">public</span>:
<a name="l00089"></a><a class="code" href="classOgre_1_1ControllerFunction.html#ae7f7207fb3ce7e252fef5941da9ebc24">00089</a>         <a class="code" href="classOgre_1_1ControllerFunction.html#ae7f7207fb3ce7e252fef5941da9ebc24" title="Constructor.">ControllerFunction</a>(<span class="keywordtype">bool</span> deltaInput)
<a name="l00090"></a>00090         {
<a name="l00091"></a>00091             <a class="code" href="classOgre_1_1ControllerFunction.html#a5141c8004f8393f985a6c06fafdb50c5" title="If true, function will add input values together and wrap at 1.0 before evaluating.">mDeltaInput</a> = deltaInput;
<a name="l00092"></a>00092             <a class="code" href="classOgre_1_1ControllerFunction.html#addf729e6eb31d54c20e9bb48b116252e">mDeltaCount</a> = 0;
<a name="l00093"></a>00093         }
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classOgre_1_1ControllerFunction.html#a00ae7d50d2009c39e90a623e47a451c3">00095</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ControllerFunction.html#a00ae7d50d2009c39e90a623e47a451c3">~ControllerFunction</a>() {}
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <span class="keyword">virtual</span> T <a class="code" href="classOgre_1_1ControllerFunction.html#a0f77d037a78ce3b430c0a18fbe711df0">calculate</a>(T sourceValue) = 0;
<a name="l00098"></a>00098     };
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00103"></a>00103     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a><a class="code" href="classOgre_1_1ControllerValue.html">00104</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ControllerAlloc</a>
<a name="l00105"></a>00105     {
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keyword">public</span>:
<a name="l00108"></a><a class="code" href="classOgre_1_1ControllerValue.html#a3f27d2383b9e994be2ee5cb71fc603fd">00108</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ControllerValue.html#a3f27d2383b9e994be2ee5cb71fc603fd">~ControllerValue</a>() { }
<a name="l00109"></a>00109         <span class="keyword">virtual</span> T <a class="code" href="classOgre_1_1ControllerValue.html#a745741bba579264e57d797683d3feacd">getValue</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1ControllerValue.html#ab719e69a47857662b71041b9c74e546b">setValue</a>(T value) = 0;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     };
<a name="l00113"></a>00113 
<a name="l00134"></a>00134     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00135"></a><a class="code" href="classOgre_1_1Controller.html">00135</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1Controller.html" title="Instances of this class &#39;control&#39; the value of another object in the system.">Controller</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ControllerAlloc</a>
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137     <span class="keyword">protected</span>:
<a name="l00139"></a><a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f">00139</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerValue&lt;T&gt;</a> &gt; <a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f" title="Source value.">mSource</a>;
<a name="l00141"></a><a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd">00141</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerValue&lt;T&gt;</a> &gt; <a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd" title="Destination value.">mDest</a>;
<a name="l00143"></a><a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73">00143</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerFunction&lt;T&gt;</a> &gt; <a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73" title="Function.">mFunc</a>;
<a name="l00145"></a><a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd">00145</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd" title="Controller is enabled or not.">mEnabled</a>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     <span class="keyword">public</span>:
<a name="l00149"></a>00149 
<a name="l00155"></a><a class="code" href="classOgre_1_1Controller.html#a3fb917fd69fdc9d6799913970039652b">00155</a>         <a class="code" href="classOgre_1_1Controller.html#a3fb917fd69fdc9d6799913970039652b" title="Usual constructor.">Controller</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue&lt;T&gt;</a> &gt;&amp; src, 
<a name="l00156"></a>00156             <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue&lt;T&gt;</a> &gt;&amp; dest, <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction&lt;T&gt;</a> &gt;&amp; func)
<a name="l00157"></a>00157             : <a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f" title="Source value.">mSource</a>(src), <a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd" title="Destination value.">mDest</a>(dest), <a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73" title="Function.">mFunc</a>(func)
<a name="l00158"></a>00158         {
<a name="l00159"></a>00159             <a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd" title="Controller is enabled or not.">mEnabled</a> = <span class="keyword">true</span>;
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161 
<a name="l00164"></a><a class="code" href="classOgre_1_1Controller.html#ab0ba3276e026fdd9d6779e043a250617">00164</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Controller.html#ab0ba3276e026fdd9d6779e043a250617" title="Default d-tor.">~Controller</a>() {}
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00168"></a><a class="code" href="classOgre_1_1Controller.html#a5432e56160bfd643bdcc0348ad191e11">00168</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Controller.html#a5432e56160bfd643bdcc0348ad191e11" title="Sets the input controller value.">setSource</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue&lt;T&gt;</a> &gt;&amp; src)
<a name="l00169"></a>00169         {
<a name="l00170"></a>00170             <a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f" title="Source value.">mSource</a> = src;
<a name="l00171"></a>00171         }
<a name="l00173"></a><a class="code" href="classOgre_1_1Controller.html#a80a9f6dd19259820c055212a70127dc1">00173</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerValue&lt;T&gt;</a> &gt;&amp; <a class="code" href="classOgre_1_1Controller.html#a80a9f6dd19259820c055212a70127dc1" title="Gets the input controller value.">getSource</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00174"></a>00174 <span class="keyword">        </span>{
<a name="l00175"></a>00175             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f" title="Source value.">mSource</a>;
<a name="l00176"></a>00176         }
<a name="l00178"></a><a class="code" href="classOgre_1_1Controller.html#af3f635f593cbe7d7973e5ab402846c5c">00178</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Controller.html#af3f635f593cbe7d7973e5ab402846c5c" title="Sets the output controller value.">setDestination</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue&lt;T&gt;</a> &gt;&amp; dest)
<a name="l00179"></a>00179         {
<a name="l00180"></a>00180             <a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd" title="Destination value.">mDest</a> = dest;
<a name="l00181"></a>00181         }
<a name="l00182"></a>00182 
<a name="l00184"></a><a class="code" href="classOgre_1_1Controller.html#aee33f3e655a58d3575bc379888794c03">00184</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerValue&lt;T&gt;</a> &gt;&amp; <a class="code" href="classOgre_1_1Controller.html#aee33f3e655a58d3575bc379888794c03" title="Gets the output controller value.">getDestination</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00185"></a>00185 <span class="keyword">        </span>{
<a name="l00186"></a>00186             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd" title="Destination value.">mDest</a>;
<a name="l00187"></a>00187         }
<a name="l00188"></a>00188 
<a name="l00190"></a><a class="code" href="classOgre_1_1Controller.html#a40ebb32894b254f53080adc1819be175">00190</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Controller.html#a40ebb32894b254f53080adc1819be175" title="Returns true if this controller is currently enabled.">getEnabled</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00191"></a>00191 <span class="keyword">        </span>{
<a name="l00192"></a>00192             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd" title="Controller is enabled or not.">mEnabled</a>;
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194 
<a name="l00196"></a><a class="code" href="classOgre_1_1Controller.html#a780a6566e4af4b23e760863f3de02028">00196</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Controller.html#a780a6566e4af4b23e760863f3de02028" title="Sets whether this controller is enabled.">setEnabled</a>(<span class="keywordtype">bool</span> enabled)
<a name="l00197"></a>00197         {
<a name="l00198"></a>00198             <a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd" title="Controller is enabled or not.">mEnabled</a> = enabled;
<a name="l00199"></a>00199         }
<a name="l00200"></a>00200 
<a name="l00203"></a><a class="code" href="classOgre_1_1Controller.html#af5d922ba593d4132e75ea6fad2848677">00203</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Controller.html#af5d922ba593d4132e75ea6fad2848677" title="Sets the function object to be used by this controller.">setFunction</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt; <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction&lt;T&gt;</a> &gt;&amp; func)
<a name="l00204"></a>00204         {
<a name="l00205"></a>00205             <a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73" title="Function.">mFunc</a> = func;
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00210"></a><a class="code" href="classOgre_1_1Controller.html#a50faa7325e4807f91f7618e0579c9245">00210</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt; ControllerFunction&lt;T&gt;</a> &gt;&amp; <a class="code" href="classOgre_1_1Controller.html#a50faa7325e4807f91f7618e0579c9245" title="Returns a pointer to the function object used by this controller.">getFunction</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00211"></a>00211 <span class="keyword">        </span>{
<a name="l00212"></a>00212             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73" title="Function.">mFunc</a>;
<a name="l00213"></a>00213         }
<a name="l00214"></a>00214 
<a name="l00220"></a><a class="code" href="classOgre_1_1Controller.html#a4b16ce7b5a436c3f895bea7960bdcb07">00220</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Controller.html#a4b16ce7b5a436c3f895bea7960bdcb07" title="Tells this controller to map it&#39;s input controller value to it&#39;s output controller value...">update</a>(<span class="keywordtype">void</span>)
<a name="l00221"></a>00221         {
<a name="l00222"></a>00222             <span class="keywordflow">if</span>(<a class="code" href="classOgre_1_1Controller.html#a9ec4cc3869f9637c506a7c05f5bf3edd" title="Controller is enabled or not.">mEnabled</a>)
<a name="l00223"></a>00223                 <a class="code" href="classOgre_1_1Controller.html#afe2a7e92f3f8ef890a236b6e3d3f6cfd" title="Destination value.">mDest</a>-&gt;setValue(<a class="code" href="classOgre_1_1Controller.html#a0e43abdb63f94385ffddd6f24ae4bd73" title="Function.">mFunc</a>-&gt;calculate(<a class="code" href="classOgre_1_1Controller.html#a4d1095860c2e682f9e24527a3e0c3c4f" title="Source value.">mSource</a>-&gt;getValue()));
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     };
<a name="l00227"></a>00227 
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
